function ComputeWelfare(ParameterFileReg,ParameterFileEst,type,Adrate,SimFile,aggregate,AllDataFile)

global NV NF 
global IDV IDF
global NDRAWS NMEM corrc
global PV PVI 
global dsm dcs alt asymmetry
global CC1 CC2 OProd

eval(ParameterFileReg);
eval(ParameterFileEst);

load(EqFile);
load(AllDataFile);
% If price random coefficient is log normal, negate variables involving
% price
if sum(IDV(1,:)==PV)>0
    if IDV(find(IDV(1,:)==PV),2)==2
        XMAT(:,PV)= -XMAT(:,PV);
        if isempty(PVI)==0
            XMAT(:,PVI(:,1)')= -XMAT(:,PVI(:,1)');
        end
    end
end

%Obtain market level price
%This is done by computing the average product price in a market. Often
%market is defined so that product price is constant within a market
MarkC=XMAT(:,mar);  %Market data column
Options=XMAT(:,alt);  %Column of options
nMarket=max(MarkC);  %Number of markets
Price=zeros(TALT,nMarket);   %Matrix to hold price
if pricedata==0
    for m=1:nMarket
        Mindex=S; 
        Mindex(Market~=m)=0;   %TALTxNCSMAXxNP matrix of market relevant obs
        Moobs=sum(sum(Mindex,2),3); %TALTx1 total obs per option in market
        for i=1:TALT
            if max(max(Mindex(i,:,:)))>0 %If option is present in market
                Price(i,m)=sum(XMAT(MarkC==m & Options==i,PV))/Moobs(i);
            end
        end
    end
    clear Mindex MTALT Moobs
elseif pricedata==1
    Price=load(PriceDataFile);
    Price=Price(:,2:nMarket+1);
end

NEWPRICE=zeros(size(XMAT,1),1);
for i=1:TALT
   for m=1:nMarket
       NEWPRICE(Options==i & MarkC==m)=Price(i,m);
   end
end
clear ops mark

%Reverse sign of price if price random coefficient is log normal
if sum(IDV(1,:)==PV)>0 && pricedata==0
    if IDV(find(IDV(1,:)==PV),2)==2
        Price=-Price;
    end    
elseif sum(IDV(1,:)==PV)>0 && pricedata==1
    if IDV(find(IDV(1,:)==PV),2)==2
        NEWPRICE=-NEWPRICE;
    end
end

%Update XMAT data to include average prices
[XMAT]=updatedata(XMAT,NEWPRICE,PV,PVI);

[X XF]=simulationdata(NP,NCSMAX,XMAT,TALT);

if type==3
    if isempty(CC2)==1
        load(Adrate);
        CC2=tau;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute perceived welfare pre ban (W is NCSMAXxNP; ww is NCSMAXxNPxNDRAWS)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[W,ww]=welfare(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,R,Group,S);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute welfare pre ban under the assumption that advertising is
% persuasive
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Following code create index of random and non-random coefficient from all
%variables that include simulation variables

RC=[];
NRC=[];
if isempty(SV)==0
    if sum(IDV(:,1)==SV)==1
        RC=[RC IDV(IDV(:,1)==SV,1)];
    elseif sum(IDF==SV)==1
        NRC=[NRC IDF(IDF==SV,1)];
    end
end
if isempty(SV2)==0
    if sum(IDV(:,1)==SV2)==1
        RC=[RC IDV(IDV(:,1)==SV2,1)];
    elseif sum(IDF==SV2)==1
        NRC=[NRC IDF(IDF==SV2,1)];
    end
end
if isempty(SVI)==0
    for i=1:size(SVI)
        if sum(IDV(:,1)==SVI(i))==1
            RC=[RC IDV(IDV(:,1)==SVI(i),1)];
        elseif sum(IDF==SVI(i))==1
            NRC=[NRC IDF(IDF==SVI(i),1)];
        end
    end
end
if isempty(SVI2)==0
    for i=1:size(SVI2)
        if sum(IDV(:,1)==SVI2(i))==1
            RC=[RC IDV(IDV(:,1)==SVI2(i),1)];
        elseif sum(IDF==SVI2(i))==1
            NRC=[NRC IDF(IDF==SVI2(i),1)];
        end
    end
end

[W_hat,ww_hat]=welfare_behave(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,S,R,Group,RC,NRC,ww);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute welfare post ban under no firm response
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Construct simulated variable 1
VSIM=zeros(NROWS,1);

inside=ones(length(XMAT),1);
NO=length(OProd);
for i=1:NO
    inside(XMAT(:,alt)==OProd(i))=0;
end

if type==1
     if IDV(find(IDV(1,:)==SV),2)==2
         VSIM(inside==1)=-CC1+CC2*XMAT(inside==1,SV);   
     else
         VSIM(inside==1)=CC1+CC2*XMAT(inside==1,SV);   
     end
elseif type==2
     if IDV(find(IDV(1,:)==SV),2)==2
         VSIM(inside==1)=-CC1*XMAT(inside==1,Factor) ...
            +XMAT(inside==1,SV);   
     else
         VSIM(inside==1)=CC1*XMAT(inside==1,Factor) ...
            +XMAT(inside==1,SV);   
     end
elseif type==3
     VSIM(inside==1)=(1+CC2*XMAT(inside==1,Factor)).* ...
         XMAT(inside==1,SV);   
end


%Update XMAT data to include simulated data
[uXMAT]=updatedata(XMAT,VSIM,SV,SVI);

if isempty(SV2)==0
    %Construct simulated variable 2
    VSIM2=zeros(NROWS,1);
    VSIM2(inside==1)=CC1+CC2*XMAT(inside==1,SV2);

    %Update XMAT data to include simulated data
    [uXMAT]=updatedata(uXMAT,VSIM2,SV2,SVI2);
end

%Construct data matrices
[XNR XFNR]=simulationdata(NP,NCSMAX,uXMAT,TALT);

% Compute welfare with firm response
[W_nr,ww_nr]=welfare(AllCoefFile,XNR,XFNR,NP,NCSMAX,TALT,DR,MDR,R,Group,S);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute welfare post ban under reoptimised prices
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(SimFile);

ops=XMAT(:,alt);
market=XMAT(:,mar);

NEWPRICE=zeros(size(XMAT,1),1);
for i=1:TALT
   for m=1:nMarket
       NEWPRICE(ops==i & market==m)=ConsumerPrice(i,m);
   end
end
clear ops 

%Reverse sign of price if price random coefficient is log normal
if sum(IDV(1,:)==PV)>0
    if IDV(find(IDV(1,:)==PV),2)==2
        NEWPRICE=-NEWPRICE;
    end
end

%Update XMAT data to include simulated data
[uXMAT]=updatedata(uXMAT,NEWPRICE,PV,PVI);

%Construct data matrices
[XR XFR]=simulationdata(NP,NCSMAX,uXMAT,TALT);

% Compute welfare with firm response
[W_r,ww_r]=welfare(AllCoefFile,XR,XFR,NP,NCSMAX,TALT,DR,MDR,R,Group,S);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute welfare in monetary terms
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[W_MM]=moneywelfare(AllCoefFile,NP,NCSMAX,DR,MDR,R,Group,ww);
[W_hat_MM]=moneywelfare(AllCoefFile,NP,NCSMAX,DR,MDR,R,Group,ww_hat);
[W_nr_MM]=moneywelfare(AllCoefFile,NP,NCSMAX,DR,MDR,R,Group,ww_nr);
[W_r_MM]=moneywelfare(AllCoefFile,NP,NCSMAX,DR,MDR,R,Group,ww_r);

if aggregate==1
    group=XMAT(:,size(XMAT,2));
    group=reshape(group,[TALT,NP]);
    market=reshape(market,[TALT,NP]);

    Data=[group(1,:)' market(1,:)' WGT' W_MM' W_hat_MM' W_nr_MM' W_r_MM'];      
elseif aggregate==0
    S=max(S,[],1);
    S=reshape(S,[NCSMAX*NP 1]);
    Group=max(Group,[],1);
    Group=reshape(Group,[NCSMAX*NP 1]);
    Market=max(Market,[],1);
    Market=reshape(Market,[NCSMAX*NP 1]);
    
    W_MM=reshape(W_MM,[NCSMAX*NP 1]);
    W_hat_MM=reshape(W_hat_MM,[NCSMAX*NP 1]);
    W_nr_MM=reshape(W_nr_MM,[NCSMAX*NP 1]);
    W_r_MM=reshape(W_r_MM,[NCSMAX*NP 1]);
    
    Data=[XMAT(XMAT(:,alt)==OProd(1),dsm) XMAT(XMAT(:,alt)==OProd(1),dcs) ...
        Group(S==1) Market(S==1) W_MM(S==1) W_hat_MM(S==1) W_nr_MM(S==1) W_r_MM(S==1)];
    
end
save(WelfareOut,'Data','-ascii','-double','-tabs');