clear

% Declare GLOBAL variables
global NP NCS NROWS
global IDV NV NAMES B W corrc
global IDF NF NAMESF F
global DRAWTYPE NDRAWS SEED1 SAVEDR PUTDR
global WANTWGT IDWGT WGT
global NALTMAX NCSMAX
global X XF S DR MDR
global XMAT
global NMEM NTAKES NPARAM

global dsm dcs choice alt mar OProd OFirm asymmetry
global PV PVI SV SVI CC1 CC2
global DataDir OutDir OutDirOr

Path='C:/DuboisGriffithOConnell.2017.ReStud';

DataDir=fullfile(Path,'Stata_files/Instrument');
OutDir=fullfile(Path,'Matlab_files/Instuments/FOTG');

%Regression options
ParameterFileReg='runs_fotg_main';

%Options common across regressions
ParameterFileEst='parm_fotg_cf';

eval(ParameterFileReg);
 
%Estimate each model
disp(R);
for i=1:12
   disp(i);
   eval(['NP=NP',int2str(i),';']);
   eval(['NCS=NCS',int2str(i),';']);
   eval(['NROWS=NROWS',int2str(i),';']);
   
   eval(['doestimates(BaseString',int2str(i),',OutString',int2str(i),',ParameterFileEst);']);
end
clear global NCSMAX DR MDR

%Combine coefficients
combine_coeffs(ParameterFileReg,ParameterFileEst);

%Computation options
ParameterFileReg='runs_fotg_comp_Feb16';
 
% %Append together data
aggregate=0;    %Set equal to one to append together aggregated data
AllDataFile=fullfile(OutDir,[OutString,'_aggdata.mat']);
combine_data(ParameterFileReg,ParameterFileEst,aggregate,AllDataFile);

%Compute elasticities and marginal costs 
aggregate=0;
AllDataFile=fullfile(OutDir,[OutString,'_aggdata.mat']);
equilibrium_cf(ParameterFileReg,ParameterFileEst,aggregate,AllDataFile);

%Output estimation results
SaveCoefs(ParameterFileReg,ParameterFileEst);

%Compute confidence intervals
bootstrap=1;
REPS=100;
bootfolder='bootstrap_fotg';
ParameterFileRegBS='runs_fotg_bootstrap';
if bootstrap==1
    drawcoefficients(ParameterFileReg,ParameterFileEst,REPS,bootfolder);
    OutDirOr=OutDir;
    for b=1:REPS
        bf=int2str(b);
        OutDir=fullfile(OutDirOr,bootfolder,bf);
        
        equilibrium_cf(ParameterFileRegBS,ParameterFileEst,aggregate,AllDataFile);
    end
end

