function [Gradv]=indexgrad(XMAT,AllCoefFile,NP,NCSMAX,TALT,DR,MDR,PV,PVI,R,Group) 

global NV NF NDRAWS NMEM NTAKES
global IDV IDF
global dsm dcs alt asymmetry OProd

load(AllCoefFile);

%Matrices to hold dXMAT/dp
GXms=zeros(TALT,NCSMAX,NV,NP); % Explanatory variables with random coefficients 
%                                 for all choice situations, for each person 
GXFms=zeros(TALT,NCSMAX,NF,NP); % Explanatory variables with fixed coefficients 
%                                 for all choice situations, for each person 

%Compute the gradient of XMAT wrt price
inside=ones(length(XMAT),1);
NO=length(OProd);
for i=1:NO
    inside(XMAT(:,alt)==OProd(i))=0;
end

GradX=zeros(size(XMAT));        %Preliminary matrix to hold dXMAT/dp
GradX(inside==1,PV)=1;
if isempty(PVI)==0
    for i=1:size(PVI,1)
        PVIc=PVI(i,1);
        MPc=PVI(i,2);

        GradX(inside==1,PVIc)=MPc*XMAT(inside==1,PVIc)...
            ./(XMAT(inside==1,PV));
    end
end

% GradX=zeros(size(XMAT));        %Preliminary matrix to hold dXMAT/dp
% GradX(XMAT(:,alt)~=OProd,PV)=1;
% if isempty(PVI)==0
%     for i=1:size(PVI,1)
%         PVIc=PVI(i,1);
%         MPc=PVI(i,2);
%     
%         GradX(XMAT(:,alt)~=OProd,PVIc)=MPc*XMAT(XMAT(:,alt)~=OProd,PVIc)...
%             ./XMAT(XMAT(:,alt)~=OProd,PV);
%     end
% end
GradX(isnan(GradX))=0;
clear index PVc MPc

cp=XMAT(:,dsm); % person

%Use GradX to fill in GXms and GXFms
 for n=1:NP;  %loop over people
 if NV > 0
    xx=GradX(cp == n, IDV(:,1)); %Selects 'random' variables for hh
 end
 if NF > 0
    xxf=GradX(cp == n, IDF(:,1)); %Selects 'fixed' variables for hh
 end
 cs=XMAT(cp == n,dcs);    %Selects choice situations for hh
  t1=cs(1,1);    %First choice situation
  t2=cs(end,1);  %Final choice situation
  
  if asymmetry==0 %Runs more quickly with identical choice sets
  
  for t=t1:t2; %loop over choice situations
      k=sum(cs==t); %Number of alts 
    if NV>0
       GXms(1:k,1+t-t1,:,n)=xx(cs==t,:);
    end
    if NF>0
       GXFms(1:k,1+t-t1,:,n)=xxf(cs==t,:);
    end;
  end
  
  else
  ops=XMAT(cp == n,alt);    %Selects options for hh
  for t=t1:t2; %loop over choice situations
     cops=ops(cs==t);
     r1=cops(1,1);
     r2=cops(end,1);
     for r=r1:r2 %loop over options
         if sum(cops==r)==1 %skip options not in choice set
             if NV>0
                 GXms(r,1+t-t1,:,n)=xx(cs==t & ops==r,:);
             end
             if NF>0
                 GXFms(r,1+t-t1,:,n)=xxf(cs==t & ops==r,:);
             end;
         end
     end
  end         
  end
 end

Group=repmat(Group,[1,1,1,NMEM]);

for r=1:NTAKES   %NTAKES is the number of draws that are are read into memory at one time                              

if NTAKES>1
   DR=MDR.Data(1).drs((r-1).*NMEM+1:r.*NMEM,:,:); %Dimensions: NMEM x NP x NV
   DR=permute(DR,[3,2,1]); %To make NV x NP x NMEM
end

Gradv=zeros(TALT,NCSMAX,NP,NMEM);
for i=1:R

 c=trans(bhat(:,i),what(:,i),DR,NP);   %c is NVxNPxNMEM matrix of b+w*dr (possibly transformed)
 if NF > 0
   ff=reshape(fhat(:,i),1,1,NF,1);  %1x1xNFx1 matrix of fixed coeffs
   ff=repmat(ff,[TALT,NCSMAX,1,NP]); %NAMxNCSMxNFxNP matrix of fixed coeffs
   vf=reshape(sum(GXFms.*ff,3),TALT,NCSMAX,NP);  %NAMxNCSMxNP matrix of f*FX
 else
   vf=zeros(TALT,NCSMAX,NP);
 end
 vf=repmat(vf,[1,1,1,NMEM]); %NAMxNCSMxNPxNMEM matrix of f*FX

 if NV >0
   
   cc=reshape(c,1,1,NV,NP,NMEM); %1x1xNVxNPxNMEM matrix of b+w*dr
   cc=repmat(cc,[TALT,NCSMAX,1,1,1]); %NAMxNCSMxNVxNPxNMEM matrix of b+w*dr
   Gradr=(repmat(GXms,[1,1,1,1,NMEM]).*cc); %NAMxNCSMxNVxNPxNMEM matrix of (b+w*dr).*RX
   Gradr=reshape(sum(Gradr,3),TALT,NCSMAX,NP,NMEM); %NAMxNCSMxNPxNMEM matrix of (b+w*dr)*RX
   Gradv(Group==i)=Gradr(Group==i)+vf(Group==i); %NAMxNCSMxNPxNMEM matrix of f*FX+(b+w*dr)*RX
 else
   Gradv(Group==i)=vf(Group==i);
 end

end
if NTAKES>1
    eval(['Gradv',int2str(r),'=Gradv;']);
end

end

if NTAKES>1
    Gradv=zeros(TALT,NCSMAX,NP,NDRAWS);
    for r=1:NTAKES
        eval(['Gradv(:,:,:,1+(r-1)*NMEM:NMEM+(r-1)*NMEM)=Gradv',int2str(r),';']);
    end
end