function [Outdata,DemanddataNR,DemanddataNE,ConsumerPrice]= ...
    simulation(ParameterFileReg,ParameterFileEst,type,FirmSimFile,Adrate,aggregate,AllDataFile)

global NV NF 
global IDV IDF
global NDRAWS NMEM
global PV PVI S
global dsm dcs alt mar asymmetry
global CC1 CC2 OProd OFirm corrc

eval(ParameterFileReg);
eval(ParameterFileEst);

load(AllDataFile);
load(EqFile);

% If price random coefficient is log normal, negate variables involving
% price
if sum(IDV(1,:)==PV)>0
    if IDV(find(IDV(1,:)==PV),2)==2
        XMAT(:,PV)= -XMAT(:,PV);
        if isempty(PVI)==0
            XMAT(:,PVI(:,1)')= -XMAT(:,PVI(:,1)');
        end
    end
end

%Obtain market level price
%This is done by computing the average product price in a market. Often
%market is defined so that product price is constant within a market
MarkC=XMAT(:,mar);  %Market data column
Options=XMAT(:,alt);  %Column of options
nMarket=max(MarkC);  %Number of markets
Price=zeros(TALT,nMarket);   %Matrix to hold price
if pricedata==0
    for m=1:nMarket
        Mindex=S; 
        Mindex(Market~=m)=0;   %TALTxNCSMAXxNP matrix of market relevant obs
        Moobs=sum(sum(Mindex,2),3); %TALTx1 total obs per option in market
        for i=1:TALT
            if max(max(Mindex(i,:,:)))>0 %If option is present in market
                Price(i,m)=sum(XMAT(MarkC==m & Options==i,PV))/Moobs(i);
            end
        end
    end
    clear Mindex MTALT Moobs
elseif pricedata==1
    Price=load(PriceDataFile);
    Price=Price(:,2:nMarket+1);
end

NEWPRICE=zeros(size(XMAT,1),1);
for i=1:TALT
   for m=1:nMarket
       NEWPRICE(Options==i & MarkC==m)=Price(i,m);
   end
end
clear ops mark

%Reverse sign of price if price random coefficient is log normal
if sum(IDV(1,:)==PV)>0 && pricedata==0
    if IDV(find(IDV(1,:)==PV),2)==2
        Price=-Price;
    end    
elseif sum(IDV(1,:)==PV)>0 && pricedata==1
    if IDV(find(IDV(1,:)==PV),2)==2
        NEWPRICE=-NEWPRICE;
    end
end

%Update XMAT data to include average prices
[XMAT]=updatedata(XMAT,NEWPRICE,PV,PVI);

if type==3
    if isempty(CC2)==1
        load(Adrate);
        CC2=tau;
    end
end

%Load ownership martix
OM=load(FirmSimFile);
ProdCode=OM(:,1);
FirmCode=OM(:,3);
clear OM

nFirms=max(FirmCode);
AllFirmsProducts=cell(nFirms,1);
AllCompetitorProducts=cell(nFirms,1);
for f=1:nFirms
    AllFirmsProducts{f}=ProdCode(FirmCode==f);
    AllCompetitorProducts{f}=ProdCode(FirmCode~=f);
end

%Construct simulated variable 1
VSIM=zeros(NROWS,1);

inside=ones(length(XMAT),1);
NO=length(OProd);
for i=1:NO
    inside(XMAT(:,alt)==OProd(i))=0;
end

if type==1
     if IDV(find(IDV(1,:)==SV),2)==2
         VSIM(inside==1)=-CC1+CC2*XMAT(inside==1,SV);   
     else
         VSIM(inside==1)=CC1+CC2*XMAT(inside==1,SV);   
     end
elseif type==2
     if IDV(find(IDV(1,:)==SV),2)==2
         VSIM(inside==1)=-CC1*XMAT(inside==1,Factor) ...
            +XMAT(inside==1,SV);   
     else
         VSIM(inside==1)=CC1*XMAT(inside==1,Factor) ...
            +XMAT(inside==1,SV);   
     end
elseif type==3
     VSIM(inside==1)=(1+CC2*XMAT(inside==1,Factor)).* ...
         XMAT(inside==1,SV);   
end

%Update XMAT data to include simulated data
[uXMAT]=updatedata(XMAT,VSIM,SV,SVI);

if isempty(SV2)==0
    %Construct simulated variable 2
    VSIM=zeros(NROWS,1);
    VSIM(inside==1)=CC1+CC2*XMAT(inside==1,SV2);

    %Update XMAT data to include simulated data
    [uXMAT]=updatedata(uXMAT,VSIM,SV2,SVI2);
end

% [DemanddataNR]=drawdemand(uXMAT,Price,NP,NCSMAX,TALT,AllCoefFile,R, ...
%     Group,Market,nMarket,mar,PriceSim,type,CC1,CC2,Factor);
DemanddataNR=[];

%Construct data matrices
[XNR, XFNR]=simulationdata(NP,NCSMAX,uXMAT,TALT);

% Compute predicted probabalities assuming no firm response
[pNR]=marketshare(AllCoefFile,XNR,XFNR,NP,NCSMAX,TALT,DR,MDR,R,Group,S);

%Compute market shares at market level assuming no firm response
[aggshareNR]=aggregatemarketshare(pNR,TALT,Market,nMarket,WGT);

clear VSIM XNR XFNS

% Set up matrices for equilibrium output for each market

ProducerPrice=Price;   % ProducerPrice will contain the Nash Equilibrium  
                       % producer prices, one vector for each market
HHConsumerPrice=XMAT(:,PV);     % Vector of Nash Consumer prices at 
                                % choice situation level
HHExitFlag=zeros(NROWS,1);      % Vector of consumer level exitflags
Residual=zeros(TALT,nMarket);   % Residual contains the vector of residuals 
                                % from the equilibrium equation - one for 
                                % each market
ExitFlag=zeros(TALT,nMarket);   % ExitFlags from nonlinear equation solver.
                                % One for each market
Output=cell(nMarket,1);         % Other output of nonlinear equation solver.

if isempty(Factor)==0
   MFactor=zeros(TALT,nMarket);
end

% Options for Nonlinear Equation Solver
FsolveOptions=optimset('DerivativeCheck','off', ...
                       'Display','iter',        ...
                       'Jacobian','on',        ...
                       'MaxFunEvals', 400,      ...
                       'MaxIter',400,           ...
                       'TolFun', [],          ...
                       'TolX',   []);

            
Mark=XMAT(:,mar);   %Vector of market data
nMarkets=max(Mark); %Number of markets

%If simulation variable is price, restore data matrix to pre-simulation
%matrix
if PriceSim==1
    uXMAT=XMAT;
end

for m=1:nMarkets
%for m=1:1
    Index=Mark==m;  %Index of observations relevant for current market

    [XMATc,Sc,Groupc,DRc,MDRc,NPc,NCSMAXc,WGTc]= ...
        marketdata(NTAKES,DR,MDR,TALT,uXMAT,WGT,NP,NCS,Index);    
    
    PreSimPrice=Price(:,m); %Pre-simulation equilibrium prices in market
    
    iPrice=(1:TALT)';    %Index of prices to be optimised

    if OutsideOptionIn==1
     NO=length(OProd);
     for i=1:NO
         iPrice=iPrice(iPrice~=OProd(i));
     end
    end
    
    if FixedPriceIn==1
        iPrice=iPrice(iPrice~=FProd);
    end
   
     x0=PreSimPrice(iPrice); %Starting values for simulated equilibrium
    
    simfun = @(x)simulationfun(x,XMATc,Sc,Groupc,DRc,MDRc,NPc,NCSMAXc,iPrice,PreSimPrice,...
        AllCoefFile,R,AllFirmsProducts,AllCompetitorProducts,costs(:,m),...
        PriceSim,TALT,IDV,WGTc,type,Factor);
       
    [P,Res,Flag,Out]=fsolve(simfun,x0,FsolveOptions);
    
    ProducerPrice(iPrice,m) = P;       
    Residual(iPrice,m)      = Res;
    ExitFlag(1:TALT,m)      = Flag;
    Output{m}               = Out;
   
    indexop=XMAT(:,alt).*Index;
    indexmk=XMAT(:,mar).*Index;
    for k=1:TALT
        HHConsumerPrice(indexop==k)=ProducerPrice(k,m);
        HHExitFlag(indexmk==k)=Flag;
    end
    
    if isempty(Factor)==0
        for j=1:TALT
           MFactor(j,m)=mean(XMATc(XMATc(:,alt)==j,Factor));
        end
    end
end

%Update data to inlude new equilibium price
Options=repmat(ProdCode,nMarket,1);
ConsumerPrice=ProducerPrice;   
if PriceSim==1
    if type==1
        HHConsumerPrice(XMAT(:,alt)~=OProd)=CC1+CC2*HHConsumerPrice(XMAT(:,alt)~=OProd);
        ConsumerPrice(ProdCode~=OProd,:)=CC1+CC2*ProducerPrice(ProdCode~=OProd,:);
    elseif type==2
        HHConsumerPrice(XMAT(:,alt)~=OProd)=CC1*XMAT(XMAT(:,alt)~=OProd,Factor) ...
            +HHConsumerPrice(XMAT(:,alt)~=OProd);
        ConsumerPrice(ProdCode~=OProd,:)=CC1.*MFactor(ProdCode~=OProd,:) ...
            +ProducerPrice(ProdCode~=OProd,:);
    elseif type==3
        HHConsumerPrice(XMAT(:,alt)~=OProd)=(1+CC2*XMAT(XMAT(:,alt)~=OProd,Factor)) ...
            .*HHConsumerPrice(XMAT(:,alt)~=OProd);
        ConsumerPrice(ProdCode~=OProd,:)=(1+CC2.*MFactor(ProdCode~=OProd,:)) ...
            .*ProducerPrice(ProdCode~=OProd,:);
    end
end

%Reverse sign of price if price random coefficient is log normal
if sum(IDV(1,:)==PV)>0
    if IDV(find(IDV(1,:)==PV),2)==2
        HHConsumerPrice=-HHConsumerPrice;
    end
end

%Update XMAT data to include simulated data
[uXMAT]=updatedata(uXMAT,HHConsumerPrice,PV,PVI);

% [DemanddataNE]=drawdemand(uXMAT,ProducerPrice,NP,NCSMAX,TALT,AllCoefFile,R, ...
%     Group,Market,nMarket,mar,PriceSim,type,CC1,CC2,Factor);
DemanddataNE=[];

%Construct data matrices
[XR XFR]=simulationdata(NP,NCSMAX,uXMAT,TALT);

% Compute predicted probabalities with firm response
[pR]=marketshare(AllCoefFile,XR,XFR,NP,NCSMAX,TALT,DR,MDR,R,Group,S);

%Compute market shares at market level with firm response
[aggshareR]=aggregatemarketshare(pR,TALT,Market,nMarket,WGT);

%Outsheet results
Mark=kron((1:nMarket)',ones(TALT,1));

testSOC=1;
if testSOC==1
    checkSOC(ParameterFileReg,ParameterFileEst,AllCoefFile,NTAKES,DR,MDR, ...
    TALT,NCSMAX,ProducerPrice,AllFirmsProducts,size(AllFirmsProducts,1),costs,uXMAT,WGT,NP,NCS)
    disp('SOCs satisfied')
end

if PriceSim==0

    Outdata=[Mark Options reshape(Simvar,[TALT*nMarket 1]) reshape(costs,[TALT*nMarket 1]) ...
        reshape(Price,[TALT*nMarket 1]) reshape(ConsumerPrice,[TALT*nMarket 1]) ...
        reshape(aggshare,[TALT*nMarket 1]) reshape(aggshareNR,[TALT*nMarket 1]) ...
        reshape(aggshareR,[TALT*nMarket 1]) reshape(ExitFlag,[TALT*nMarket 1])];

    % 1  Market
    % 2  Option
    % 3  Simulation variable
    % 4  Costs
    % 5  Pre-simulation price
    % 6  Post-simulation price
    % 7  Pre-simulation share
    % 8  Post-simulation share (no firm response)
    % 9  Post-simulation share (firm response)
        
elseif PriceSim==1
    ConsumerPriceNR=zeros(size(Price));
    if type==1
        ConsumerPriceNR(ProdCode~=OProd,:)=CC1+CC2*Price(ProdCode~=OProd,:);
    elseif type==2
        ConsumerPriceNR(ProdCode~=OProd,:)=CC1.*MFactor(ProdCode~=OProd,:) ...
            +Price(ProdCode~=OProd,:);
    elseif type==3
        ConsumerPriceNR(ProdCode~=OProd,:)=(1+CC2.*MFactor(ProdCode~=OProd,:)) ...
            .*Price(ProdCode~=OProd,:);
    end

    if isempty(Factor)==0
            Outdata=[Mark Options reshape(MFactor,[TALT*nMarket 1]) reshape(costs,[TALT*nMarket 1]) ...
            reshape(Price,[TALT*nMarket 1]) reshape(ConsumerPriceNR,[TALT*nMarket 1]) ...
            reshape(ConsumerPrice,[TALT*nMarket 1]) reshape(aggshare,[TALT*nMarket 1]) ...
            reshape(aggshareNR,[TALT*nMarket 1]) reshape(aggshareR,[TALT*nMarket 1])];
    else
            Outdata=[Mark Options reshape(costs,[TALT*nMarket 1]) ...
            reshape(Price,[TALT*nMarket 1]) reshape(ConsumerPriceNR,[TALT*nMarket 1]) ...
            reshape(ConsumerPrice,[TALT*nMarket 1]) reshape(aggshare,[TALT*nMarket 1]) ...
            reshape(aggshareNR,[TALT*nMarket 1]) reshape(aggshareR,[TALT*nMarket 1])];
    end        
    % 1  Market
    % 2  Option
    % 2a Factor
    % 3  Costs
    % 4  Pre-simulation price
    % 5  Post-simulation price (no firm response)
    % 6  Post-simulation price (firm response)
    % 7  Pre-simulation share
    % 8  Post-simulation share (no firm response)
    % 9  Post-simulation share (firm response)
end

if aggregate==1 && R>1
    DisData=[XMAT(:,size(XMAT,2)) XMAT(:,mar) XMAT(:,alt) ...
        kron(WGT',ones(TALT,1)) reshape(squeeze(pNR),[TALT*NP 1]) ...
        reshape(squeeze(pR),[TALT*NP 1]) HHExitFlag];
    save(DisSimOut,'DisData','-ascii','-double','-tabs');
elseif aggregate==0 && R>1
    pNRo=reshape(pNR,[TALT*NCSMAX*NP 1]);
    pRo=reshape(pR,[TALT*NCSMAX*NP 1]);
    So=reshape(S,[TALT*NCSMAX*NP 1]);
    DisData=[XMAT(:,dsm) XMAT(:,dcs) XMAT(:,size(XMAT,2)) XMAT(:,mar) XMAT(:,alt)  ...
         pNRo(So==1) pRo(So==1) HHExitFlag];
    save(DisSimOut,'DisData','-ascii','-double','-tabs');    
end    

if type==2
    [tau]=fixADtau(ConsumerPriceNR,Price,aggshareNR,NP,NCSMAX,NROWS, ...
    XMAT,TALT,Factor,MFactor,nMarket,Market,CC1,ProdCode,AllCoefFile,DR,MDR,R,Group,S,WGT);
    save(Adrate,'tau');
end
