function [X XF]=simulationdata(NP,NCSMAX,XMAT,TALT)

global NV NF 
global IDV IDF
global dsm dcs alt asymmetry

%Matrices to hold data after price is adjusted
X=zeros(TALT,NCSMAX,NV,NP); % Explanatory variables with random coefficients
%                                 for all choice situations, for each person
XF=zeros(TALT,NCSMAX,NF,NP); % Explanatory variables with fixed coefficients
%                                 for all choice situations, for each person


cp=XMAT(:,dsm); % person

for n=1:NP;  %loop over people
 if NV > 0
    xx=XMAT(cp == n, IDV(:,1)); %Selects 'random' variables for hh
 end
 if NF > 0
    xxf=XMAT(cp == n, IDF(:,1)); %Selects 'fixed' variables for hh
 end
 cs=XMAT(cp == n,dcs);    %Selects choice situations for hh
  t1=cs(1,1);    %First choice situation
  t2=cs(end,1);  %Final choice situation

  if asymmetry==0 %Runs more quickly with identical choice sets

   for t=t1:t2; %loop over choice situations
       k=sum(cs==t); %Number of alts
     if NV>0
        X(1:k,1+t-t1,:,n)=xx(cs==t,:);
     end
     if NF>0
        XF(1:k,1+t-t1,:,n)=xxf(cs==t,:);
     end;
  end

  else

   ops=XMAT(cp == n,alt);    %Selects options for hh
   for t=t1:t2; %loop over choice situations
      cops=ops(cs==t);
      r1=cops(1,1);
      r2=cops(end,1);
      for r=r1:r2 %loop over options
          if sum(cops==r)==1 %skip options not in choice set
              if NV>0
                  X(r,1+t-t1,:,n)=xx(cs==t & ops==r,:);
              end
              if NF>0
                  XF(r,1+t-t1,:,n)=xxf(cs==t & ops==r,:);
              end;
          end
      end
   end
  end

end