% Input b has dimension NVx1. 
% Input w has dimension NVx1.
% Input dr are the draws and have dimension NV x NP x NMEM  
% Output c has dimension NVxNPxNMEM.
% Uses IDV to determine transformations of draws in dr.

function c=trans(b,w,dr,NP)
 
 global IDV NV NMEM corrc

  if NV>0
     if corrc==1
      L=zeros(NV,NV);
      x=0;
      for i=1:NV
           for j=1:i
             L(i,j)=w(x+1);
             x=x+1;
           end
      end
  
      eta=zeros(NV,NP,NMEM);
      for p=1:NP
         for m=1:NMEM
             eta(:,p,m)=L*squeeze(dr(:,p,m));
         end
      end
     elseif corrc==0
         eta=repmat(w,[1,NP,NMEM]).*dr;
     end
    c=repmat(b,[1,NP,NMEM])+eta;                %Create NVxNPxNMEM matrix of b+w*dr
    c(IDV(:,2) == 2,:,:)=exp(c(IDV(:,2) == 2,:,:));     %Transform log normal 
    c(IDV(:,2) == 3,:,:)=c(IDV(:,2) == 3,:,:).*(c(IDV(:,2) == 3,:,:)>0);    %Tranform truncated normal
    c(IDV(:,2) == 4,:,:)=exp(c(IDV(:,2) == 4,:,:))./(1+exp(c(IDV(:,2) == 4,:,:)));   %Transform logistic
 else
    c=[];
 end
