use "$DataA/RGadverts.dta"

*****************************
** describe ads by brand/channel
*****************************

lab def agg_brand 1 "Pringles" 2 "Walkers Regular" 3 "Walkers Sensation" 4 "Walkers Doritos" 5 "Walkers Other" 6 "KP" 7 "GW" 8 "Asda" 9 "Tesco" 10 "Other"
lab val agg_brand agg_brand

    gen x=.
    replace x=2 if station==           "Alibi"
    replace x=2 if station==    "AnimalPlanet"
    replace x=2 if station==       "Biography"
    replace x=2 if station==         "Blighty"
    replace x=2 if station==             "Box"
    replace x=2 if station==           "Bravo"
    replace x=1 if station==              "C4"
    replace x=1 if station==              "C5"
    replace x=1 if station==       "Challenge"
    replace x=1 if station==         "ComedyC"
    replace x=1 if station==           "Crime"
    replace x=1 if station==            "Dave"
    replace x=2 if station==       "Discovery"
    replace x=2 if station==   "DiscoveryHist"
    replace x=2 if station==   "DiscoveryHome"
    replace x=2 if station==   "DiscoveryReal"
    replace x=1 if station==              "E4"
    replace x=2 if station==            "Eden"
    replace x=2 if station==              "FX"
    replace x=1 if station==           "Film4"
    replace x=1 if station==         "FiveUSA"
    replace x=1 if station==           "Fiver"
    replace x=2 if station==            "GOLD"
    replace x=2 if station==         "History"
    replace x=2 if station==            "Home"
    replace x=1 if station==            "ITV1"
    replace x=1 if station==            "ITV2"
    replace x=1 if station==            "ITV3"
    replace x=1 if station==            "ITV4"
    replace x=2 if station==          "Living"
    replace x=2 if station==         "Living2"
    replace x=1 if station==             "MTV"
    replace x=1 if station==           "More4"
    replace x=2 if station==       "NationalG"
    replace x=1 if station==          "Really"
    replace x=2 if station==            "Sky1"
    replace x=2 if station==            "Sky2"
    replace x=2 if station==            "Sky3"
    replace x=2 if station==        "SkyBoxOf"
    replace x=2 if station==       "SkyMovies"
    replace x=2 if station==         "SkyNews"
    replace x=2 if station==      "SkyRealLiv"
    replace x=2 if station==       "SkySports"
    replace x=2 if station==      "SkySportsN"
    replace x=2 if station==         "Trouble"
    replace x=2 if station==        "UKTVFood"
    replace x=2 if station==             "VH1"
    replace x=2 if station==           "Watch"
    replace x=1 if station==       "Yesterday"
lab def x 1 "free to air/freeview" 2 "cable/satellite"
lab val x x

gen nad=1
ren expenditure exp
*collapse (sum) nad exp length,by(agg_brand week ym x)
collapse (sum) nad exp length,by(agg_brand week x)
fillin agg_brand week x
drop _fillin
foreach v in nad exp length {
   replace `v'=0 if `v'==.
}
*reshape wide nad exp length,j(x) i(agg_brand week ym)
reshape wide nad exp length,j(x) i(agg_brand week)
gen nad=nad1+nad2
gen exp=exp1+exp2
gen length=length1+length2
table agg_brand,c(m nad m exp m length) format(%6.0f)

lab def week 6 "Feb 2009"
forval v=7(1)105 {
 lab def week `v' ".",modify
 }
lab def week 32 "August 2009",modify
lab def week 58 "Feb 2010",modify
lab def week 84 "August 2010",modify
lab val week week

**Figure 4.1
graph bar nad1 nad2 if agg_brand==1,over(week, lab(angle(vertical) labsize(vsmall))) legend(order(1 "free to air/freeview" 2 "cable/satellite")) stack  bar(1, col(black)) bar(2, col(gs11)) ytitle(Adverts) title(Pringles,color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/Pringles_byweek.png",replace
graph bar nad1 nad2 if agg_brand==2,over(week, lab(angle(vertical) labsize(vsmall))) legend(order(1 "free to air/freeview" 2 "cable/satellite")) stack  bar(1, col(black)) bar(2, col(gs11)) ytitle(Adverts) title(Walkers Regular,color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/WalkersRegular_byweek.png",replace
graph bar nad1 nad2 if agg_brand==3,over(week, lab(angle(vertical) labsize(vsmall))) legend(order(1 "free to air/freeview" 2 "cable/satellite")) stack  bar(1, col(black)) bar(2, col(gs11)) ytitle(Adverts) title(Walkers Sensation,color(black)) graphr(color(white)) bgcolor(white)


*** construct Table 4.1 descriptives of adverts
use "$DataA/RGadverts_detail.dta",clear

drop if year==2010 & month>10

lab def agg_brand 1 "Pringles" 2 "Walkers Regular" 3 "Walkers Sensation" 4 "Walkers Doritos" 5 "Walkers Other" 6 "KP" 7 "GW" 8 "Asda" 9 "Tesco" 10 "Other"
lab val agg_brand agg_brand

gen nad=1
ren expenditure exp
collapse (sum) nad exp length,by(agg_brand week)
fillin agg_brand week
replace nad=0 if nad==.
replace exp=0 if exp==.
replace length=0 if length==.
gen adzero=nad==0
table agg_brand,c(sum adzero m nad sd nad m exp m length) format(%6.0f)

**Table 4.1
tabout agg_brand using "$T\TVadsperweek.tex", cells(sum adzero mean nad sd nad mean exp mean length)  format(0) sum style(tex)  replace

** show that brands advertise during different shows/different times
use "$DataA/RGadverts.dta",clear

keep if show1=="Coronation Street"|show1=="Hollyoaks"

gen nad=1
ren expenditure exp
collapse (sum) nad exp length,by(agg_brand show1 week)
fillin agg_brand show1 week
drop _fillin
replace nad=0 if nad==.

lab def week 6 "Feb 2009"
forval v=7(1)105 {
 lab def week `v' ".",modify
 }
lab def week 32 "August 2009",modify
lab def week 58 "Feb 2010",modify
lab def week 84 "August 2010",modify
lab val week week

**Figure 4.2
graph bar nad if agg_brand==1&show1=="Coronation Street",over(week, lab(angle(vertical) labsize(vsmall))) bar(1, col(black)) ytitle(Adverts) title(Pringles during Coronation Street (ITV),color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/Pringles_CSt.png",replace
graph bar nad if agg_brand==2&show1=="Coronation Street",over(week, lab(angle(vertical) labsize(vsmall))) bar(1, col(black)) ytitle(Adverts) title(Walkers Regular during Coronation Street (ITV),color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/WalkersRegular_CSt.png",replace

graph bar nad if agg_brand==1&show1=="Hollyoaks",over(week, lab(angle(vertical) labsize(vsmall))) bar(1, col(black)) ytitle(Adverts) title(Pringles during Hollyoaks (C4),color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/Pringles_HO.png",replace
graph bar nad if agg_brand==2&show1=="Hollyoaks",over(week, lab(angle(vertical) labsize(vsmall))) bar(1, col(black)) ytitle(Adverts) title(Walkers Regular during Hollyoaks (C4),color(black)) graphr(color(white)) bgcolor(white)
graph export "$T/WalkersRegular_HO.png",replace
graph bar nad if agg_brand==3&show1=="Hollyoaks",over(week, lab(angle(vertical) labsize(vsmall))) bar(1, col(black)) ytitle(Adverts) title(Walkers Sensations during Hollyoaks (C4),color(black)) graphr(color(white)) bgcolor(white)

*****************************
** describe hh flows and stocks
*****************************

u "$DataA/disagg_ad_stocks_ft.dta",clear

** this plots three households to show how there is variation in flows and this translates into variation in stocks
keep hhno week own_flow own_stock agg_brand
keep if hhno==34591|hhno==176739|hhno==111226
reshape wide own_flow own_stock,j(hhno) i(week agg_brand)
   lab def week 6 "Feb 2009"
   forval w=7(1)105 {
    lab def week `w' ".",modify
   }
   lab def week 32 "August",modify
   lab def week 58 "Feb 2010",modify
   lab def week 84 "August",modify
   lab val week week

so week

**Figure 4.3
line own_flow34591 own_flow176739 own_flow111226 week if agg_brand==2, xlab(6 "Feb 2009" 32 "Aug 2009" 58 "Feb 2010" 84 "Aug 2010") lcolor(black black black) lpattern(solid longdash_dot shortdash) ytitle(Impressions) title("Household flow exposure to Walkers Regular adverts",color(black)) legend(order(1 "1" 2 "2" 3 "3" ) row(1) title(Household,color(black))) graphr(color(white)) bgcolor(white)
graph export "$T/OwnFlowHH.png",replace

line own_stock34591 own_stock176739  own_stock111226 week if agg_brand==2, xlab(6 "Feb 2009" 32 "Aug 2009" 58 "Feb 2010" 84 "Aug 2010") lcolor(black black black) lpattern(solid longdash_dot shortdash) ytitle(Impressions) title("Household stock exposure to Walkers Regular adverts",color(black)) legend(order(1 "1" 2 "2" 3 "3" ) row(1) title(Household,color(black))) graphr(color(white)) bgcolor(white)
graph export "$T/OwnStockHH.png",replace

