insheet using "$In_out/fotgadfinite.raw",clear

rename v1 market
rename v2 product
rename v3 brand_ad
rename v4 sh_sim
drop v5-v6

drop if brand_ad==8|brand_ad==9
drop if product==12|product==13

rename brand_ad brand_adold

gen     brand_ad = 2  if brand_adold==1
replace brand_ad = 3  if brand_adold==2
replace brand_ad = 4  if brand_adold==3
replace brand_ad = 5  if brand_adold==4
replace brand_ad = 6  if brand_adold==5
replace brand_ad = 7  if brand_adold==6
replace brand_ad = 10 if brand_adold==7

drop brand_adold

gen     brand = 2  if product==1|product==2
replace brand = 3  if product==3
replace brand = 4  if product==4
replace brand = 5  if product==5|product==6
replace brand = 6  if product==7
replace brand = 7  if product==8|product==9
replace brand = 10 if product==10|product==11

merge m:1 market product using "$Out/fotg_products.dta",keepusing(share price cost)
keep if _m==3
drop _m

merge m:1 market product using "$Data/fotg_sizecost.dta",keepusing(size)
keep if _m==3
drop _m

gen q_sim  = sh_sim*($Outsize/12)*size
gen q_base = share*($Outsize/12)*size

replace product = product+100

keep market product brand brand_ad q_base q_sim price cost

sa "$Out/fotg_ad_exp.dta",replace

insheet using "$In_in/fiadfinite.raw",clear

rename v1 market
rename v2 product
rename v3 brand_ad
rename v4 sh_sim
drop v5-v6

drop if brand_ad==11|brand_ad==12
drop if product==27|product==28

merge m:1 market product using "$Out/fi_products.dta",keepusing(brand share price cost)
keep if _m==3
drop _m

merge m:1 market product using "$Data/fi_sizecost.dta",keepusing(size)
keep if _m==3
drop _m

gen q_sim  = sh_sim*($Insize/12)*size
gen q_base = share*($Insize/12)*size

gen purch_sim  = sh_sim*($Insize/12)
gen purch_base = share*($Insize/12)

keep market product brand brand_ad q_base q_sim purch_base purch_sim price cost

append using "$Out/fotg_ad_exp.dta"

sa "$Out/ad_exp.dta",replace

u "$Out/ad_exp.dta",clear

collapse (sum) q_base q_sim,by(market brand brand_ad)

collapse (mean) q_base q_sim,by(brand brand_ad)

gen delta = ((q_sim-q_base)/q_base)*100

drop q*

reshape wide delta,i(brand) j(brand_ad)

rename delta1  Pringles
rename delta2  Walkers_Reg
rename delta3  Walkers_Sens
rename delta4  Walkers_Dor
rename delta5  Walkers_Oth
rename delta6  KP
rename delta7  GW
rename delta8  Asda
rename delta9  Tesco
rename delta10 Other

sa "$Out/ad_brand.dta",replace

u "$Out/ad_exp.dta",clear

gen prof_base = (price-cost)*purch_base
gen prof_sim  = (price-cost)*purch_sim

collapse (sum) prof_base prof_sim,by(market brand brand_ad)

merge m:1 brand market using "$Data/ad_flow.dta"
drop if _m==2
drop _m

replace own_flow = 0 if brand!=brand_ad
replace prof_base = prof_base-own_flow

gen     firm = 1 if brand==1
replace firm = 2 if brand==2 | brand==3 | brand==4 | brand==5
replace firm = 3 if brand==6
replace firm = 4 if brand==7
replace firm = 5 if brand==8
replace firm = 6 if brand==9
replace firm = 7 if brand==10

collapse (sum) prof_base prof_sim,by(market firm brand_ad)

collapse (mean) prof_base prof_sim,by(firm brand_ad)

gen delta = ((prof_sim-prof_base)/prof_base)*100

drop prof*

reshape wide delta,i(firm) j(brand_ad)

rename delta1  Pringles
rename delta2  Walkers_Reg
rename delta3  Walkers_Sens
rename delta4  Walkers_Dor
rename delta5  Walkers_Oth
rename delta6  KP
rename delta7  GW
rename delta8  Asda
rename delta9  Tesco
rename delta10 Other

sa "$Out/ad_prof.dta",replace

u "$Out/ad_exp.dta",clear

collapse (sum) q_base q_sim,by(market brand_ad)

collapse (mean) q_base q_sim,by(brand_ad)

gen delta = ((q_sim-q_base)/q_base)*100

drop q*

gen i = 1
reshape wide delta,i(i) j(brand_ad)
drop i

rename delta1  Pringles
rename delta2  Walkers_Reg
rename delta3  Walkers_Sens
rename delta4  Walkers_Dor
rename delta5  Walkers_Oth
rename delta6  KP
rename delta7  GW
rename delta8  Asda
rename delta9  Tesco
rename delta10 Other

sa "$Out/ad_brand_tot.dta",replace

u "$Out/ad_exp.dta",clear

keep if brand==brand_ad
drop brand_ad

gen     size = 1 if product>100
replace size = 2 if product==9|product==12|product==15|product==18|product==21|product==24
replace size = 3 if product==1|product==3|product==5|product==7|product==10|product==13|product==16|product==19|product==22|product==25
replace size = 4 if product==2|product==4|product==6|product==8|product==11|product==14|product==17|product==20|product==23|product==26

drop if size==1

collapse (sum) q_base q_sim,by(market brand size)

collapse (mean) q_base q_sim,by(brand size)

gen delta = (q_sim-q_base)*1000

drop q*

reshape wide delta,i(size) j(brand)

rename delta1  Pringles
rename delta2  Walkers_Reg
rename delta3  Walkers_Sens
rename delta4  Walkers_Dor
rename delta5  Walkers_Oth
rename delta6  KP
rename delta7  GW
rename delta8  Asda
rename delta9  Tesco
rename delta10 Other

sa "$Out/ad_size.dta",replace

drop size
collapse (sum) *

sa "$Out/ad_size_tot.dta",replace

insheet using "$In_in/fimelas.raw",clear

rename v1 market
rename v2 altop
rename v3 altpr
rename v4 elas
drop v5

lab var market       "Index of market"
lab var altop        "Share product"
lab var altpr        "Price product"
lab var elas         "Price elasticity"

keep if altop==altpr
rename altop product

keep product market elas

sa "$Out/fi_ownpriceelas.dta",replace

insheet using "$In_in/fiadfinite.raw",clear

rename v1 market
rename v2 product
rename v3 brand_ad
rename v4 sh_sim
rename v5 ad_elas
drop v6

drop if brand_ad==11
drop if product==27

merge m:1 market product using "$Out/fi_products.dta",keepusing(brand share)
keep if _m==3
drop _m

merge m:1 market product using "$Data/fi_sizecost.dta",keepusing(size)
keep if _m==3
drop _m

merge m:1 market product using "$Out/fi_ownpriceelas.dta"
keep if _m==3
drop _m

gen q_sim  = sh_sim*($Insize/12)*size
gen q_base = share*($Insize/12)*size

keep if brand==brand_ad

replace ad_elas = ((ad_elas-elas)/elas)*100

collapse (mean) ad_elas elas,by(product brand)

keep if product==1|product==2|product==3|product==4|product==12|product==13|product==14

gen     size = 1 if product==12
replace size = 2 if product==1|product==3|product==13
replace size = 3 if product==2|product==4|product==14
drop product

reshape wide ad_elas elas,i(size) j(brand)

label def size 1 "<150g" 2 "150g-300g" 3 "300g+"
lab val size size

rename elas1    Pringles_eq
rename ad_elas1 Pringles_na
rename elas2    Walker_Reg_eq
rename ad_elas2 Walker_Reg_na
rename elas6    KP_eq
rename ad_elas6 KP_na

order size Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

sa "$Out/ad_priceelas.dta",replace

u "$Out/ad_exp.dta",clear

keep if brand==brand_ad
drop brand_ad

gen     size = 1 if product>100
replace size = 2 if product==9|product==12|product==15|product==18|product==21|product==24
replace size = 3 if product==1|product==3|product==5|product==7|product==10|product==13|product==16|product==19|product==22|product==25
replace size = 4 if product==2|product==4|product==6|product==8|product==11|product==14|product==17|product==20|product==23|product==26

drop if size==1

collapse (sum) q_base q_sim,by(market brand size)

collapse (mean) q_base q_sim,by(brand size)

gen delta = ((q_sim-q_base)/q_base)*100

drop q*

reshape wide delta,i(size) j(brand)

rename delta1  Pringles
rename delta2  Walkers_Reg
rename delta3  Walkers_Sens
rename delta4  Walkers_Dor
rename delta5  Walkers_Oth
rename delta6  KP
rename delta7  GW
rename delta8  Asda
rename delta9  Tesco
rename delta10 Other

sa "$Out/ad_size_rob.dta",replace

