**************************************************************************
***Advertising effects
**************************************************************************

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_brand.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_brand_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_brand.dta"

    replace b = `v' if b==.

    sa "$Out/ad_brand_append_ci.dta",replace
}

u "$Out/ad_brand_append_ci.dta",clear

keep brand Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(brand)
    egen `v'ub = pctile(`v'),p(97.5) by(brand)
}

bysort brand: keep if _n==1

keep brand Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(brand) j(stat) string

sa "$Out/ad_brand_ci.dta",replace

u "$Out/ad_brand.dta",clear

keep brand Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_brand_ci.dta"

cap lab def brand_full 1 "Pringles" 2 "Walkers Regular" 3 "Walkers Sensations" 4 "Walkers Doritos" 5 "Walkers Other" 6 "KP" 7 "Golden Wonder" 8 "Asda" 9 "Tesco" 10 "Other"
lab val brand brand_full

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(brand) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep brand Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

gen     ot = 1  if brand==2
replace ot = 2  if brand==3
replace ot = 3  if brand==4
replace ot = 4  if brand==5
replace ot = 5  if brand==1
replace ot = 6  if brand==6
replace ot = 7  if brand==7
replace ot = 8  if brand==8
replace ot = 9  if brand==9
replace ot = 10 if brand==10
cap lab def ota 1 "Walkers Regular" 2 "Walkers Sensations" 3 "Walkers Doritos" 4 "Walkers Other" 5 "Pringles" 6 "KP" 7 "Golden Wonder" 8 "Asda" 9 "Tesco" 10 "Other"
lab val ot ota

sort ot
local z=1
forval x=1/10 {
    local brandname  :   label  (ot)   `x'
    if `z'==1 listtab   Walkers_Regout2 Pringlesout2 KPout2  using "$T/brandad_CF.tex" in `z' , begin(`brandname'&)  rstyle(tabular)  replace
    if `z'>1  listtab   Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`brandname'&)  rstyle(tabular)  appendto("$T/brandad_CF.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/brandad_CF.tex")   begin(&)
    local z=`z'+1
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_brand_tot.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_brand_tot_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_brand_tot.dta"

    replace b = `v' if b==.

    sa "$Out/ad_brand_tot_append_ci.dta",replace
}

u "$Out/ad_brand_tot_append_ci.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(tot)
    egen `v'ub = pctile(`v'),p(97.5) by(tot)
}

bysort tot: keep if _n==1

keep tot Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(tot) j(stat) string

sa "$Out/ad_brand_tot_ci.dta",replace

u "$Out/ad_brand_tot.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_brand_tot_ci.dta"

cap lab def tot 1 ""
lab val tot tot

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(tot) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep tot Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

local z=1
forval x=1/1 {
    local totname  :   label  (tot)   `x'
    if `z'==1 listtab  Walkers_Regout2 Pringlesout2 KPout2  using "$T/brandad_tot_CF.tex" in `z' , begin(`totname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`totname'&)  rstyle(tabular)  appendto("$T/brandad_tot_CF.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/brandad_tot_CF.tex")   begin(&)
    local z=`z'+1
    }


forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_size.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_size_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_size.dta"

    replace b = `v' if b==.

    sa "$Out/ad_size_append_ci.dta",replace
}

u "$Out/ad_size_append_ci.dta",clear

keep size Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(size) j(stat) string

sa "$Out/ad_size_ci.dta",replace

u "$Out/ad_size.dta",clear

keep size Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_size_ci.dta"

cap lab def size 1 "Single pack" 2 "$<$150g" 3 "150g-300g" 4 "300g+"
lab val size size

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(size) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep size Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

gen o = ""

local z=1
forval x=2/4 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab   Walkers_Regout2 Pringlesout2 KPout2  using "$T/sizead_CF.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o  CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_CF.tex")   begin(&)
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/sizead_CF.tex" )
    if `z'>1  listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_CF.tex")   begin(&)
    local z=`z'+1
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_size_tot.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_size_tot_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_size_tot.dta"

    replace b = `v' if b==.

    sa "$Out/ad_size_tot_append_ci.dta",replace
}

u "$Out/ad_size_tot_append_ci.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(tot)
    egen `v'ub = pctile(`v'),p(97.5) by(tot)
}

bysort tot: keep if _n==1

keep tot Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(tot) j(stat) string

sa "$Out/ad_size_tot_ci.dta",replace

u "$Out/ad_size_tot.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_size_tot_ci.dta"

cap lab def tot 1 ""
lab val tot tot

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(tot) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep tot Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

local z=1
forval x=1/1 {
    local totname  :   label  (tot)   `x'
    if `z'==1 listtab  Walkers_Regout2 Pringlesout2 KPout2  using "$T/sizead_tot_CF.tex" in `z' , begin(`totname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`totname'&)  rstyle(tabular)  appendto("$T/sizead_tot_CF.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_tot_CF.tex")   begin(&)
    local z=`z'+1
    }


forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_priceelas.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_priceelas_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_priceelas.dta"

    replace b = `v' if b==.

    sa "$Out/ad_priceelas_append_ci.dta",replace
}

u "$Out/ad_priceelas_append_ci.dta",clear

keep size Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Walker_Reg_eqlb Walker_Reg_nalb Pringles_eqlb Pringles_nalb KP_eqlb KP_nalb Walker_Reg_equb Walker_Reg_naub Pringles_equb Pringles_naub KP_equb KP_naub

reshape long Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na,i(size) j(stat) string

sa "$Out/ad_priceelas_ci.dta",replace

u "$Out/ad_priceelas.dta",clear

keep size Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

gen stat = "mean"

append using "$Out/ad_priceelas_ci.dta"

cap lab def size 1 "<150g" 2 "150g-300g" 3 "300g+"
lab val size size

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Walker_Reg_eqout Walker_Reg_naout Pringles_eqout Pringles_naout KP_eq KP_naout, i(size) j(stat)

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep size Walker_Reg_eqout2 Walker_Reg_naout2 Pringles_eqout2 Pringles_naout2 KP_eqout2 KP_naout2 CIWalker_Reg_eq CIWalker_Reg_na CIPringles_eq CIPringles_na CIKP_eq CIKP_na

gen o = ""

local z=1
forval x=1/3 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab  Walker_Reg_eqout2  Pringles_eqout2 KP_eqout2 Walker_Reg_naout2 Pringles_naout2 KP_naout2  using "$T/priceelasad_CF.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o CIKP_eq o o  CIKP_na in `z' ,   rstyle(tabular)  appendto("$T/priceelasad_CF.tex")   begin(&)
    if `z'>1  listtab  Walker_Reg_eqout2  Pringles_eqout2 KP_eqout2 Walker_Reg_naout2 Pringles_naout2 KP_naout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/priceelasad_CF.tex" )
    if `z'>1  listtab  CIWalker_Reg_eq  CIPringles_eq CIKP_eq CIWalker_Reg_na CIPringles_na CIKP_na in `z' ,   rstyle(tabular)  appendto("$T/priceelasad_CF.tex")   begin(&)
    local z=`z'+1
    }

