
forval v = 1/$BR {
    insheet using "$FOTGMF/bootstrap_fotg/`v'/fotgsimulations.raw",clear
    keep v10
    su v10
    local l = r(mean)

    gen b = `v'
    gen ok = `l'==1
    keep if _n==1

    drop v10

    if `v'>1 append using "$Out/fotg_bs_index.dta"

    sa "$Out/fotg_bs_index.dta",replace
}

forval v = 1/$BR {
    insheet using "$FoodInMF/bootstrap_fi/`v'/fisimulations.raw",clear
    keep v10
    su v10
    local l = r(mean)

    gen b = `v'
    gen ok_i = `l'==1
    keep if _n==1

    drop v10

    if `v'>1 append using "$Out/fi_bs_index.dta"

    sa "$Out/fi_bs_index.dta",replace
}
u "$Out/fi_bs_index.dta",clear

merge 1:1 b using "$Out/fotg_bs_index.dta"
drop _m

keep if ok==1&ok_i==1

keep b
sort b
keep if _n<501

sa "$Out/bs_index.dta",replace

**************************************************************************
**Willingness to pay
**************************************************************************
forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/wtp.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/wtp_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/wtp.dta"

    replace b = `v' if b==.
    disp `v'
    sa "$Out/wtp_append_ci.dta",replace
}

u "$Out/wtp_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

foreach v in wtp_rp10 wtp_rp50 wtp_rp90 {
    egen `v'lb = pctile(`v'),p(2.5) by(v)
    egen `v'ub = pctile(`v'),p(97.5) by(v)
}

bysort vr: keep if _n==1
keep vr wtp_rp10lb wtp_rp50lb wtp_rp90lb wtp_rp10ub wtp_rp50ub wtp_rp90ub

reshape long wtp_rp10 wtp_rp50 wtp_rp90,i(v) j(stat) string

sa "$Out/wtp_ci.dta",replace

u "$Out/wtp.dta",clear

gen stat = "mean"

append using "$Out/wtp_ci.dta"

lab def vr 1 "Food in the home" 2 "" 3 "Food on-the-go" 4 ""
lab val vr vr

drop out change

foreach v in wtp_rp10 wtp_rp50 wtp_rp90 {
*    gen `v'out=round(`v',0.01)
*    format `v'out %4.2f
    gen `v'out=round(`v',0.1)
    format `v'out %4.1f
    }

drop wtp_rp10 wtp_rp50 wtp_rp90

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide wtp_rp10 wtp_rp50 wtp_rp90, i(vr) j(stat)

foreach v in wtp_rp10 wtp_rp50 wtp_rp90 {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep vr wtp_rp10out2 wtp_rp50out2 wtp_rp90out2 CIwtp_rp10 CIwtp_rp50 CIwtp_rp90

gen str type = "Willingness to pay in pence" if vr==1|vr==3
replace type = "\% of mean price" if vr==2|vr==4

gen o = ""

***Table 4.5

local z=1
forval x=1/4  {
    local vrname  :   label  (vr)   `x'
    if `z'==1 listtab  type wtp_rp10out2 wtp_rp50out2 wtp_rp90out2  using "$T/wtp.tex" in `z' , begin(`vrname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  type wtp_rp10out2 wtp_rp50out2 wtp_rp90out2  in `z'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/wtp.tex" )
    listtab  o CIwtp_rp10 CIwtp_rp50 CIwtp_rp90 in `z' ,   rstyle(tabular)  appendto("$T/wtp.tex")   begin(&)
    local z=`z'+1
    }


**************************************************************************
***Advertising effects
**************************************************************************

u "$Data/ad_flow.dta",clear

collapse own_flow,by(brand)

gen i = 1
reshape wide own_flow,i(i) j(brand)

rename own_flow1   Pringles
rename own_flow2   Walkers_Reg
rename own_flow3   Walkers_Sens
rename own_flow4   Walkers_Dor
rename own_flow5   Walkers_Oth
rename own_flow6   KP
rename own_flow7   GW
rename own_flow8   Asda
rename own_flow9   Tesco
rename own_flow10  Other

keep i Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.001)
    format `v'out %5.3f
    }

keep i Pringlesout Walkers_Regout KPout

lab def i 1 "Advertising expenditure (\pounds m)"
lab val i i

local z=1
forval x=1/1 {
    local iname  :   label  (i)   `x'
    if `z'==1 listtab  Walkers_Regout Pringlesout KPout  using "$T/adexp.tex" in `z' , begin(`iname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkers_Regout Pringlesout KPout in `z'  , begin(`iname'&)  rstyle(tabular)  appendto("$T/adexp.tex" )
    local z=`z'+1
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_brand.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_brand_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_brand.dta"

    replace b = `v' if b==.

    sa "$Out/ad_brand_append_ci.dta",replace
}

u "$Out/ad_brand_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

keep brand Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(brand)
    egen `v'ub = pctile(`v'),p(97.5) by(brand)
}

bysort brand: keep if _n==1

keep brand Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(brand) j(stat) string

sa "$Out/ad_brand_ci.dta",replace

u "$Out/ad_brand.dta",clear

keep brand Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_brand_ci.dta"

cap lab def brand_full 1 "Pringles" 2 "Walkers Regular" 3 "Walkers Sensations" 4 "Walkers Doritos" 5 "Walkers Other" 6 "KP" 7 "Golden Wonder" 8 "Asda" 9 "Tesco" 10 "Other"
lab val brand brand_full

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(brand) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep brand Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

gen     ot = 1  if brand==2
replace ot = 2  if brand==3
replace ot = 3  if brand==4
replace ot = 4  if brand==5
replace ot = 5  if brand==1
replace ot = 6  if brand==6
replace ot = 7  if brand==7
replace ot = 8  if brand==8
replace ot = 9  if brand==9
replace ot = 10 if brand==10
cap lab def ota 1 "Walkers Regular" 2 "Walkers Sensations" 3 "Walkers Doritos" 4 "Walkers Other" 5 "Pringles" 6 "KP" 7 "Golden Wonder" 8 "Asda" 9 "Tesco" 10 "Other"
lab val ot ota

***Table 4.7

sort ot
local z=1
forval x=1/10 {
    local brandname  :   label  (ot)   `x'
    if `z'==1 listtab   Walkers_Regout2 Pringlesout2 KPout2  using "$T/brandad.tex" in `z' , begin(`brandname'&)  rstyle(tabular)  replace
    if `z'>1  listtab   Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`brandname'&)  rstyle(tabular)  appendto("$T/brandad.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/brandad.tex")   begin(&)
    local z=`z'+1
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_brand_tot.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_brand_tot_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_brand_tot.dta"

    replace b = `v' if b==.

    sa "$Out/ad_brand_tot_append_ci.dta",replace
}

u "$Out/ad_brand_tot_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

gen tot = 1
keep tot Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(tot)
    egen `v'ub = pctile(`v'),p(97.5) by(tot)
}

bysort tot: keep if _n==1

keep tot Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(tot) j(stat) string

sa "$Out/ad_brand_tot_ci.dta",replace

u "$Out/ad_brand_tot.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_brand_tot_ci.dta"

cap lab def tot 1 ""
lab val tot tot

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(tot) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep tot Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

***Table 4.7

local z=1
forval x=1/1 {
    local totname  :   label  (tot)   `x'
    if `z'==1 listtab  Walkers_Regout2 Pringlesout2 KPout2  using "$T/brandad_tot.tex" in `z' , begin(`totname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`totname'&)  rstyle(tabular)  appendto("$T/brandad_tot.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/brandad_tot.tex")   begin(&)
    local z=`z'+1
    }


forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_size.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_size_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_size.dta"

    replace b = `v' if b==.

    sa "$Out/ad_size_append_ci.dta",replace
}

u "$Out/ad_size_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

keep size Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(size) j(stat) string

sa "$Out/ad_size_ci.dta",replace

u "$Out/ad_size.dta",clear

keep size Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_size_ci.dta"

cap lab def size 1 "Single pack" 2 "$<$150g" 3 "150g-300g" 4 "300g+"
lab val size size

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(size) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep size Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

gen o = ""

***Table 4.8

local z=1
forval x=2/4 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab   Walkers_Regout2 Pringlesout2 KPout2  using "$T/sizead.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o  CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead.tex")   begin(&)
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/sizead.tex" )
    if `z'>1  listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead.tex")   begin(&)
    local z=`z'+1
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_size_tot.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_size_tot_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_size_tot.dta"

    replace b = `v' if b==.

    sa "$Out/ad_size_tot_append_ci.dta",replace
}

u "$Out/ad_size_tot_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

gen tot = 1
keep tot Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(tot)
    egen `v'ub = pctile(`v'),p(97.5) by(tot)
}

bysort tot: keep if _n==1

keep tot Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(tot) j(stat) string

sa "$Out/ad_size_tot_ci.dta",replace

u "$Out/ad_size_tot.dta",clear

gen tot = 1
keep tot Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_size_tot_ci.dta"

cap lab def tot 1 ""
lab val tot tot

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(tot) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep tot Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

***Table 4.8

local z=1
forval x=1/1 {
    local totname  :   label  (tot)   `x'
    if `z'==1 listtab  Walkers_Regout2 Pringlesout2 KPout2  using "$T/sizead_tot.tex" in `z' , begin(`totname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`totname'&)  rstyle(tabular)  appendto("$T/sizead_tot.tex" )
    listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_tot.tex")   begin(&)
    local z=`z'+1
    }



forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_priceelas.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_priceelas_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_priceelas.dta"

    replace b = `v' if b==.

    sa "$Out/ad_priceelas_append_ci.dta",replace
}

u "$Out/ad_priceelas_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

keep size Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Walker_Reg_eqlb Walker_Reg_nalb Pringles_eqlb Pringles_nalb KP_eqlb KP_nalb Walker_Reg_equb Walker_Reg_naub Pringles_equb Pringles_naub KP_equb KP_naub

reshape long Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na,i(size) j(stat) string

sa "$Out/ad_priceelas_ci.dta",replace

u "$Out/ad_priceelas.dta",clear

keep size Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

gen stat = "mean"

append using "$Out/ad_priceelas_ci.dta"

cap lab def size 1 "<150g" 2 "150g-300g" 3 "300g+"
lab val size size

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Walker_Reg_eqout Walker_Reg_naout Pringles_eqout Pringles_naout KP_eq KP_naout, i(size) j(stat)

foreach v in Walker_Reg_eq Walker_Reg_na Pringles_eq Pringles_na KP_eq KP_na {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep size Walker_Reg_eqout2 Walker_Reg_naout2 Pringles_eqout2 Pringles_naout2 KP_eqout2 KP_naout2 CIWalker_Reg_eq CIWalker_Reg_na CIPringles_eq CIPringles_na CIKP_eq CIKP_na

gen o = ""

***Table 4.6

local z=1
forval x=1/3 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab  Walker_Reg_eqout2  Pringles_eqout2 KP_eqout2 Walker_Reg_naout2 Pringles_naout2 KP_naout2  using "$T/priceelasad.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o CIKP_eq o o  CIKP_na in `z' ,   rstyle(tabular)  appendto("$T/priceelasad.tex")   begin(&)
    if `z'>1  listtab  Walker_Reg_eqout2  Pringles_eqout2 KP_eqout2 Walker_Reg_naout2 Pringles_naout2 KP_naout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/priceelasad.tex" )
    if `z'>1  listtab  CIWalker_Reg_eq  CIPringles_eq CIKP_eq CIWalker_Reg_na CIPringles_na CIKP_na in `z' ,   rstyle(tabular)  appendto("$T/priceelasad.tex")   begin(&)
    local z=`z'+1
    }


forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/ad_size_rob.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/ad_size_rob_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/ad_size_rob.dta"

    replace b = `v' if b==.

    sa "$Out/ad_size_rob_append_ci.dta",replace
}

u "$Out/ad_size_rob_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

keep size Pringles Walkers_Reg KP

foreach v in Pringles Walkers_Reg KP {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Pringleslb Walkers_Reglb KPlb Pringlesub Walkers_Regub KPub

reshape long Pringles Walkers_Reg KP,i(size) j(stat) string

sa "$Out/ad_size_rob_ci.dta",replace

u "$Out/ad_size_rob.dta",clear

keep size Pringles Walkers_Reg KP

gen stat = "mean"

append using "$Out/ad_size_rob_ci.dta"

cap lab def size 1 "Single pack" 2 "$<$150g" 3 "150g-300g" 4 "300g+"
lab val size size

foreach v in Pringles Walkers_Reg KP {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Pringles Walkers_Reg KP

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkers_Regout KPout, i(size) j(stat)

foreach v in Pringles Walkers_Reg KP {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep size Pringlesout2 Walkers_Regout2 KPout2 CIPringles CIWalkers_Reg CIKP

gen o = ""

***For Table 4.14

local z=1
forval x=2/4 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab   Walkers_Regout2 Pringlesout2 KPout2  using "$T/sizead_rob.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o  CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_rob.tex")   begin(&)
    if `z'>1  listtab  Walkers_Regout2 Pringlesout2 KPout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/sizead_rob.tex" )
    if `z'>1  listtab  CIWalkers_Reg CIPringles CIKP in `z' ,   rstyle(tabular)  appendto("$T/sizead_rob.tex")   begin(&)
    local z=`z'+1
    }



**************************************************************************
***Aggregate results
**************************************************************************

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/aggregate_results.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/aggregate_results_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/aggregate_results.dta"
    replace b = `v' if b==.

    sa "$Out/aggregate_results_append_ci.dta",replace

    if `v'==1 u "$OutAll/Bootstrap/`v'/aggregate_insidesize.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/aggregate_insidesize_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/aggregate_insidesize.dta"
    replace b = `v' if b==.

    sa "$Out/aggregate_insidesize_append_ci.dta",replace
}

u "$Out/aggregate_insidesize_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

drop var

foreach v in pre post_nr post_r {
    egen `v'lb = pctile(`v'),p(2.5) by(vr)
    egen `v'ub = pctile(`v'),p(97.5) by(vr)
}

bysort vr: keep if _n==1
keep vr prelb post_nrlb post_rlb preub post_nrub post_rub

reshape long pre post_nr post_r,i(vr) j(stat) string

sa "$Out/aggregate_insidesize_ci.dta",replace

u "$Out/aggregate_results_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

drop var

foreach v in pre post_nr post_r {
    egen `v'lb = pctile(`v'),p(2.5) by(vr)
    egen `v'ub = pctile(`v'),p(97.5) by(vr)
}

bysort vr: keep if _n==1
keep vr prelb post_nrlb post_rlb preub post_nrub post_rub

reshape long pre post_nr post_r,i(vr) j(stat) string

append using "$Out/aggregate_insidesize_ci.dta"

sort vr stat

sa "$Out/aggregate_results_ci.dta",replace


u "$Out/aggregate_results.dta",clear

append using "$Out/aggregate_insidesize.dta"
sort vr

drop var

gen stat = "mean"

append using "$Out/aggregate_results_ci.dta"

foreach v in pre post_nr post_r {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
*    gen `v'out=round(`v',0.1)
*    format `v'out %4.1f
    }
drop pre post_nr post_r

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide preout post_nrout post_rout, i(vr) j(stat)

foreach v in pre post_nr post_r {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep vr preout2 post_nrout2 post_rout2 CIpre CIpost_nr CIpost_r
gen o=""

lab def a1 1 "Expenditure (\pounds m)" 2 "\textit{\% change}" 3 "Quantity (mKg)" 4 "\textit{\% change}" 5 "Nutrient score" 6 "\textit{\% change}" 7 "Profits (\pounds m)" 8 "\textit{\% change}" 9  "Energy (b kj)" 10 "\textit{\% change}" 11 "Saturates (1000 kg)" 12 "\textit{\% change}" 13 "Salt (1000 kg)" 14 "\textit{\% change}" 15 "Energy intensity (kj/100g)" 16 "\textit{\% change}" 17 "Saturates intensity (g/100g)" 18 "\textit{\% change}" 19 "Salt intensity (g/100g)" 20 "\textit{\% change}" 21 "Probability of selecting potato chips (\%)" 22 "\textit{Change}" 23 "Mean pack size conditional on purchase (g)" 24 "\textit{\% change}" 25 "Probability of selecting unhealthy outside option (\%)" 26 "\textit{Change}" 27 "Probability of selecting healthy outside option (\%)" 28 "\textit{Change}"
lab val vr a1

**Table 4.10

foreach x of numlist 1 2 3 4 {
    local vrname  :   label  (vr)   `x'
    if `x'==1 listtab  preout2 post_nrout2 post_rout2  using "$T/aggregate_results.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>1  listtab  preout2 post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/aggregate_results.tex" )
    if `x'==1|`x'==3|`x'==21|`x'==23 listtab  CIpre CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_results.tex")   begin(&)
    if `x'==2|`x'==4|`x'==22|`x'==24 listtab  o CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_results.tex")   begin(&)
    }

**Table 4.11

foreach x of numlist 9 10 11 12 13 14 {
    local vrname  :   label  (vr)   `x'
    if `x'==9 listtab  preout2 post_nrout2 post_rout2  using "$T/aggregate_hresults1.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>9  listtab  preout2 post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/aggregate_hresults1.tex" )
    if `x'==9|`x'==11|`x'==13 listtab  CIpre CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_hresults1.tex")   begin(&)
    if `x'==10|`x'==12|`x'==14 listtab  o CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_hresults1.tex")   begin(&)
    }

**Table 4.11

foreach x of numlist 5 6 17 18 19 20 {
    local vrname  :   label  (vr)   `x'
    if `x'==5 listtab  preout2 post_nrout2 post_rout2  using "$T/aggregate_hresults2.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>5  listtab  preout2 post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/aggregate_hresults2.tex" )
    if `x'==5|`x'==17|`x'==19 listtab  CIpre CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_hresults2.tex")   begin(&)
    if `x'==6|`x'==18|`x'==20 listtab  o CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_hresults2.tex")   begin(&)
    }

**Table 4.12

foreach x of numlist 21 22 25 26 27 28 {
    local vrname  :   label  (vr)   `x'
    if `x'==21 listtab  preout2 post_nrout2 post_rout2  using "$T/outside_results.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>21  listtab  preout2 post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/outside_results.tex" )
    if `x'==21|`x'==25|`x'==27 listtab  CIpre CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/outside_results.tex")   begin(&)
    if `x'==22|`x'==26|`x'==28 listtab  o CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/outside_results.tex")   begin(&)
    }

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/aggregate_welfare_results.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/aggregate_welfare_results_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/aggregate_welfare_results.dta"
    replace b = `v' if b==.

    sa "$Out/aggregate_welfare_results_append_ci.dta",replace
}

u "$Out/aggregate_welfare_results_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

drop var

foreach v in post_nr post_r {
    egen `v'lb = pctile(`v'),p(2.5) by(vr)
    egen `v'ub = pctile(`v'),p(97.5) by(vr)
}

bysort vr: keep if _n==1
keep vr post_nrlb post_rlb post_nrub post_rub

reshape long post_nr post_r,i(vr) j(stat) string

sa "$Out/aggregate_welfare_results_ci.dta",replace

u "$Out/aggregate_welfare_results.dta",clear

drop var

gen stat = "mean"

append using "$Out/aggregate_welfare_results_ci.dta"

foreach v in post_nr post_r {
**    gen `v'out=round(`v',0.01)
**    format `v'out %4.2f
    gen `v'out=round(`v',0.1)
    format `v'out %4.1f
    }
drop post_nr post_r

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide post_nrout post_rout, i(vr) j(stat)

foreach v in post_nr post_r {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep vr post_nrout2 post_rout2 CIpost_nr CIpost_r
gen o=""

lab def a2 1 "Characteristics effect (\pounds m)" 2 "Price competition effect (\pounds m)" 3 "\textit{Total compensating variation (\pounds m)}" 4 "\textit{Change in profits (\pounds m)}" 5 "\textbf{Total change in welfare (\pounds m)}" 6 "\textit{\% change}" 7 "Profits (\pounds m)" 8 "\textit{\% change}" 6 "Choice distortion effect (\pounds m)" 7 "Price competition effect (\pounds m)" 8 "\textit{Total compensating variation (\pounds m)}" 9 "\textit{Change in profits (\pounds m)}" 10 "\textbf{Total change in welfare (\pounds m)}"
lab val vr a2

**Table 4.13

local z=1
forvalues x=1/5 {
    local vrname  :   label  (vr)   `x'
    if `z'==1 listtab  post_nrout2 post_rout2  using "$T/aggregate_welfare_results1.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/aggregate_welfare_results1.tex" )

    if `z'!=2 listtab  CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_welfare_results1.tex")   begin(&)
    if `z'==2 listtab  o CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_welfare_results1.tex")   begin(&)
    local z=`z'+1
    }

forvalues x=6/10 {
    local vrname  :   label  (vr)   `x'
    if `x'==6 listtab  post_nrout2 post_rout2  using "$T/aggregate_welfare_results2.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>6  listtab  post_nrout2 post_rout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/aggregate_welfare_results2.tex" )

    if `x'!=7 listtab  CIpost_nr CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_welfare_results2.tex")   begin(&)
    if `x'==7 listtab  o CIpost_r in `x' ,   rstyle(tabular)  appendto("$T/aggregate_welfare_results2.tex")   begin(&)
    }

**************************************************************************
***Effect of ban on prices
**************************************************************************

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/fi_simprice.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/fi_simprice_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/fi_simprice.dta"

    replace b = `v' if b==.

    sa "$Out/fi_simprice_append_ci.dta",replace
}

u "$Out/fi_simprice_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

keep size Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post

foreach v in Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post {
    egen `v'lb = pctile(`v'),p(2.5) by(size)
    egen `v'ub = pctile(`v'),p(97.5) by(size)
}

bysort size: keep if _n==1

keep size Walker_Reg_prelb Walker_Reg_postlb Pringles_prelb Pringles_postlb KP_prelb KP_postlb Walker_Reg_preub Walker_Reg_postub Pringles_preub Pringles_postub KP_prelb KP_postub

reshape long Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post,i(size) j(stat) string

sa "$Out/fi_simprice_ci.dta",replace

u "$Out/fi_simprice.dta",clear

keep size Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post

gen stat = "mean"

append using "$Out/fi_simprice_ci.dta"

cap lab def size 1 "<150g" 2 "150g-300g" 3 "300g+"
lab val size size

foreach v in Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post {
    gen `v'out=round(`v',0.01)
    format `v'out %6.2f
    }

drop Walker_Reg_pre Walker_Reg_post Pringles_pre Pringles_post KP_pre KP_post

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Walker_Reg_preout Walker_Reg_postout Pringles_preout Pringles_postout KP_preout KP_postout, i(size) j(stat)

foreach v in Walker_Reg_post Pringles_post KP_post {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }
keep size Walker_Reg_preout2 Walker_Reg_postout2 Pringles_preout2 Pringles_postout2 KP_preout2 KP_postout2 CIWalker_Reg_post CIPringles_post CIKP_post

gen o = ""

**Table 4.9

local z=1
forval x=1/3 {
    local sizename  :   label  (size)   `x'
    if `z'==1 listtab  Walker_Reg_preout2 Walker_Reg_postout2 Pringles_preout2 Pringles_postout2 KP_preout2 KP_postout2  using "$T/simprice.tex" in `z' , begin(`sizename'&)  rstyle(tabular)  replace
    if `z'==1 listtab  o o o o  o CIKP_post in `z' ,   rstyle(tabular)  appendto("$T/simprice.tex")   begin(&)
    if `z'>1  listtab  Walker_Reg_preout2 Walker_Reg_postout2 Pringles_preout2 Pringles_postout2 KP_preout2 KP_postout2 in `z'  , begin(`sizename'&)  rstyle(tabular)  appendto("$T/simprice.tex" )
    if `z'>1  listtab  o CIWalker_Reg_post o CIPringles_post o CIKP_post in `z' ,   rstyle(tabular)  appendto("$T/simprice.tex")   begin(&)
    local z=`z'+1
    }



